# install "plspm"
install.packages("plspm")
library(plspm)

mobile<-read.table("mobile.txt",header=T,row.names=1,sep="\t")

IMA = c(0,0,0,0,0,0,0)
EXP = c(1,0,0,0,0,0,0)
PQUAL=c(0,1,0,0,0,0,0)
PVAL =c(0,1,1,0,0,0,0)
SAT = c(1,1,1,1,0,0,0) 
COMPL=c(0,0,0,0,1,0,0)
LOY = c(1,0,0,0,1,1,0)

# path matrix
mobile_path = rbind(IMA, EXP, PQUAL, PVAL, SAT,COMPL, LOY)
colnames(mobile_path) = rownames(mobile_path)

# define list of blocks (outer model)
mobile_blocks = list(1:5, 6:8, 9:15, 16:17, 18:20, 21, 22:24)

# vector of modes (reflective indicators)
mobile_modes = rep("A", 7)

# run the function
mobile_pls = plspm(mobile, mobile_path, mobile_blocks, modes = mobile_modes, boot.val = F)
# outputs
mobile_pls
summary(mobile_pls)
innerplot(mobile_pls)
outerplot(mobile_pls)

# bootstrap
mobile_pls = plspm(mobile, mobile_path, mobile_blocks, modes = mobile_modes, boot.val = T, br=300)
summary(mobile_pls)


# run nmpls option 
mobile_scalingNum = list(rep("num",5),
rep("num",3),
rep("num",7),
rep("num",2),
rep("num",3),
rep("num",1),
rep("num",3)
)
mobile_nmplsNum = plspm(mobile, mobile_path, mobile_blocks, scaling= mobile_scalingNum, modes = mobile_modes, boot.val = F)
summary(mobile_nmplsNum)

mobile_scalingOrd = list(
rep("ord",5),
rep("ord",3),
rep("ord",7),
rep("ord",2),
rep("ord",3),
rep("ord",1),
rep("ord",3)
)
mobile_nmplsOrd = plspm(mobile, mobile_path, mobile_blocks, scaling= mobile_scalingOrd, modes = mobile_modes, boot.val = F)
summary(mobile_nmplsOrd)
for (i in 1:7) {
	quartz()
	quantiplot(mobile_nmplsOrd,lv=colnames(mobile_path)[i]);
}

mobile_scalingNom = list(
rep("nom",5),
rep("nom",3),
rep("nom",7),
rep("nom",2),
rep("nom",3),
rep("nom",1),
rep("nom",3)
)
mobile_nmplsNom = plspm(mobile, mobile_path, mobile_blocks, scaling= mobile_scalingNom, modes = mobile_modes, boot.val = F)
summary(mobile_nmplsNom)
for (i in 1:7) {
	quartz()
	quantiplot(mobile_nmplsNom,lv=colnames(mobile_path)[i]);
}











